<i18n lang="yml">
en:
  problem_location: "Problem location"
  attention_location: "Attention location"
  other_location: "No ABP location"
nl:
  problem_location: "Probleemlocatie"
  attention_location: "Aandachtslocatie"
  other_location: "Geen ABP-locatie"
</i18n>

<template>
  <div
    :class="$style['operational-panel-map']"
    @click="clicked"
    @mouseover="mouseOver"
  >
    <mapbox
      access-token="pk.eyJ1IjoiYW1zdGVyZGFtIiwiYSI6ImNrZDdiY3VvbDA5cGsyc25uZjF6aWpvY3QifQ.TwL_Hb39_-wa4AW2binG3Q"

      :map-options="{
        style: 'mapbox://styles/amsterdam/ckd7cljs00gao1iljsec16mck/draft',
        ...MAPOPTIONS,
      }"
      :nav-control="{
        show: true,
        showCompass: false,
        position: 'bottom-right'
      }"
      :attribution-control="{
        position: 'bottom-left'
      }"

      :class="$style['map']"

      @map-load="loaded"
      @map-move="move"
    />

    <div :class="$style['filter-labels']">
      <div
        v-for="label in filterLabels"
        :key="label.filteredBy"
        :class="$style['label']"
        :data-label="label.filteredBy"
        @click="closeLabel"
      >
        <span :class="$style['icon-close']">×</span><span style="margin-left: 0.5rem;">{{ $t(label.filteredOn) }}</span>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
  onMounted,
  watch,
} from "@nuxtjs/composition-api";

// Util libraries
import { debounce, throttle } from "lodash";

// Mapbox
import Mapbox from "mapbox-gl-vue";
import mapboxgl, { PointLike } from "mapbox-gl";

// Composables
import useGlobals from "~/composables/globals";
import useRowFoldout from "~/composables/row-foldout";
import useMapping from "~/components/Views/Operational/composables/mapping";
import useFiltering from "~/composables/filtering";
import useScansPrep from "~/components/Views/Operational/composables/scans-prep";

export default defineComponent({
  name: "AmsOperationalPanelMap",

  components: {
    Mapbox,
  },

  setup () {
    const { POST_FILTERABLE_PROPS, MAPOPTIONS } = useGlobals();
    const { STATE } = inject("store");
    const { foldoutState } = useRowFoldout();

    const filterLabels = computed(() => {
      const activeLabels = [];

      if (STATE.loaded.scans) {
        POST_FILTERABLE_PROPS.forEach((label) => {
          if (STATE.filters.valueFor[label] && STATE.filters.valueFor[label] !== "all") {
            activeLabels.push({
              filteredBy: label,
              filteredOn: STATE.filters.valueFor[label],
            });
          }
        });
      }

      return activeLabels;
    });

    let mapObj = null;

    /**
     * Update the map's layers and view parameters.
     */
    function updateMap () {
      const { setNewMarkers, flyToFiltered } = useMapping();

      setNewMarkers();

      setTimeout(flyToFiltered, 500);
    }

    /**
     * Call plotting functions when map is loaded.
     * @param { object } map - Mapbox Map object.
     */
    function loaded (map: mapboxgl.Map) {
      const { preparedScanRows } = useScansPrep();
      const { fetchClusters } = useMapping(map, preparedScanRows);

      mapObj = map;

      const promisedClusters = fetchClusters();

      promisedClusters
        .then(() => {
          setTimeout(updateMap, 500);
        })
        .catch(console.error)
      ;

      watch(
        () => foldoutState.openedFoldout,
        debounce((newValue) => {
          if (newValue && mapObj) {
            // @ts-ignore
            const scan: any = preparedScanRows.value.find(scan => scan.cluster_location.subValue.properties.remote_id === newValue);

            if (scan) {
              // @ts-ignore
              const coords: PointLike = scan.cluster_location.subValue.geometry.coordinates;

              mapObj.flyTo({
                center: coords,
                zoom: 21,
                speed: 2,
                curve: 1.5,
              });
            }
          }
        }, 500, {
          leading: false,
          trailing: true,
        }),
      );
    }

    /**
     * Interact with map by clicking and tapping.
     * @param { object } event - Click event.
     */
    const clicked = throttle((event) => {
      if (!event.target.classList.contains("marker")) {
        return;
      }

      if (event.target.dataset.clusterId) {
        const clusterId = event.target.dataset.clusterId;

        foldoutState.openedFoldout = clusterId;
      } else {
        const coords = event.target.dataset.coordinates.split(",");
        const currentZoom = mapObj.getZoom();
        const newZoom = currentZoom + 1.5 <= 21 ? currentZoom + 1.5 : 21;

        mapObj.flyTo({
          center: coords,
          zoom: newZoom,
          speed: 2,
          curve: 1.5,
        });
      }

      // highlightMarker(event.target.parentElement);
    }, 250);

    function closeLabel ($event) {
      const { filter } = useFiltering();
      const target = $event.target;
      const filterBy = target.dataset.label ? target.dataset.label : target.parentElement.dataset.label;
      filter("", filterBy);
    }

    /**
     * Actions when a mouse cursor moves over a feature.
     * @param { object } event - Mouse-over event.
     */
    const mouseOver = throttle((event) => {
      if (!event.target.classList.contains("marker")) {
        foldoutState.markerHighlighted = [];
        return;
      }

      if (event.target.dataset.clusterId) {
        const clusterId = event.target.dataset.clusterId;

        foldoutState.markerHighlighted = [clusterId];
      }
    }, 250);

    /**
     * Actions when map is panned or otherwise moved.
     */
    const move = throttle(() => {
      if (mapObj) {
        const { updateMarkers } = useMapping();

        updateMarkers();
      }
    }, 750);

    onMounted(() => {
      if (mapObj) {
        setTimeout(updateMap, 500);
      }
    });

    watch(() => STATE.loaded.scans, (newValue) => {
      if (newValue && mapObj) {
        setTimeout(updateMap, 500);
      }
    });

    return {
      MAPOPTIONS,
      filterLabels,
      loaded,
      clicked,
      closeLabel,
      mouseOver,
      move,
    };
  },
});
</script>

<style lang="postcss" module>
.operational-panel-map {
  min-height: 240px;

  @apply w-full h-full select-none;

  .map {
    @apply w-full h-full;

    @screen lg {
      min-height: calc(100vh - var(--appheader-height, 4.375rem));
    }
  }

  .filter-labels {
    @apply absolute top-0 left-0 mt-4 ml-8 flex flex-wrap;

    .label {
      padding-top: 1.5px;

      @apply flex justify-center items-center mr-2 mb-2 px-2 h-8 bg-gray-700 font-semibold text-sm text-white cursor-pointer;

      .icon-close {
        padding-top: 1px;

        @apply font-bold text-2xl;
      }
    }
  }
}
</style>

<style lang="postcss">
.mapboxgl-marker {
  position: absolute;
  transition:
    opacity 150ms ease,
    transform 50ms ease,
  ;

  svg {
    transition: transform 150ms ease;
  }

  &:hover,
  &[data-focus-visible-added],
  &.is-highlighted {
    svg {
      transform: scale(1.5);
    }
  }
}

.marker {
  @apply absolute top-0 left-0 opacity-0 w-full h-full;
}
</style>
